    // 使用if來取得週天的名稱
    // function getWeekdayName(weekday){ 
    //   var weekdayName;
    //   if (weekday === 0 ) weekdayName = "Sunday";
    //   if (weekday === 1 ) weekdayName = "Monday";
    //   if (weekday === 2 ) weekdayName = "Tuesday";
    //   if (weekday === 3 ) weekdayName = "Wednesay";
    //   if (weekday === 4 ) weekdayName = "Thursday";
    //   if (weekday === 5 ) weekdayName = "Friday";
    //   if (weekday === 6 ) weekdayName = "Saturay";
    //   return weekdayName;
    // }

    // 使用陣列來取得週天的名稱
    function getWeekdayName(weekday){
      var weekdayNames =  ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];
      return weekdayNames[weekday];
    }


    function getMonthName(month){
      switch (month)  {        
        case 0: return "January";
        case 1: return "February";
        case 2: return "March";
        case 3: return "April";        
        case 4: return "May";        
        case 5: return "June";        
        case 6: return "July";
        case 7: return "August";
        case 8: return "September";
        case 9: return "October";
        case 10: return "November";                                    
        case 11: return "December";        
      }
    }

    function addDateOrdinal(date) { //加上日期序數
      switch (date) {
        case 1:
        case 21:
        case 31: return date + "<sup>st</sup>";

        case 2:
        case 22: return date + "<sup>nd</sup>";        

        case 3:
        case 23: return date + "<sup>rd</sup>";        

        default: return date + "<sup>th</sup>";      
      }

    }

    function updateDates(){
      let today = new Date();  //新增一個Date物件，命名為today

      document.getElementById("cur-year").innerHTML = today.getFullYear();
      document.getElementById("back-year").innerHTML = today.getFullYear();
      document.getElementById("cal-year").innerHTML = today.getFullYear();

      document.getElementById("cur-month").innerHTML = getMonthName( today.getMonth() );
      document.getElementById("cal-month").innerHTML = getMonthName( today.getMonth() );

      document.getElementById("cur-date").innerHTML = addDateOrdinal( today.getDate() );

      document.getElementById("cur-day").innerHTML = getWeekdayName(today.getDay());

    }

    var currentColor = { 
      name : "blue", 
      color : "#1B19CD", 
      off_color : "#7c7EFB" 
    };

    var color_data = [
      {
          name: 'blue',
          color_code: '#1B19CD',
          off_color_code: '#7C7EFB'
      }, {
          name: 'red',
          color_code: '#D01212',
          off_color_code: '#EEA19B'
      }, {
          name: 'purple',
          color_code: '#721D89',
          off_color_code: '#EBADFB'
      }, {
          name: 'green',
          color_code: '#158348',
          off_color_code: '#57C664'
      }, {
          name: 'orange',
          color_code: '#EE742D',
          off_color_code: '#F7A77A'
      }, {
          name: 'deep-orange',
          color_code: '#F13C26',
          off_color_code: '#F77D59'
      }, {
          name: 'baby-blue',
          color_code: '#31B2FC',
          off_color_code: '#3D8DD9'
      }, {
          name: 'cerise',
          color_code: '#EA3D69',
          off_color_code: '#FCBECC'
      }, {
          name: 'lime',
          color_code: '#2ACC32',
          off_color_code: '#4FFA4F'
      }, {
          name: 'teal',
          color_code: '#2FCCB9',
          off_color_code: '#7FE7E3'
      }, {
          name: 'pink',
          color_code: '#F50D7A',
          off_color_code: '#FFB9EA'
      }, {
          name: 'black',
          color_code: '#212524',
          off_color_code: '#687E7B'
      }
    ];

    //用程式的方式去打開色彩對話方塊，讓使用者選取色彩，確認後，按下"Update"按鈕…
    function openFavColor(){
      var modal = document.getElementById("modal");
      modal.open = true;
      var template = document.getElementById("fav-color");
      template.removeAttribute("hidden");
    }
    
    // 變更色彩，關閉色彩對話方塊
    function changeColor(){

      color_data.forEach(function(arr_data){ //陣列的走訪，每走訪一個陣列元素，帶出的元素以arr_data變數呈現(arr_data我們自取的名稱)
        if(currentColor.name == arr_data.name){ //找到color_data陣列中符合的色彩，
            currentColor.color = arr_data.color_code;
            currentColor.off_color = arr_data.off_color_code;
        }
      });
      // console.log(currentColor.name + "," + currentColor.color + "," + currentColor.off_color);

      var elements;

      //先清除掉所有的style設置(td)
      elements = document.getElementsByTagName("td");
      for(let i=0; i < elements.length; i++) {
            elements[i].style = null;
      }      

      //改變目前的色彩設置
      elements = document.getElementsByClassName("color"); //找出所有有設置color類別的元素
      for(let i=0; i < elements.length; i++) {
        elements[i].style.backgroundColor = currentColor.color;
      }

      elements = document.getElementsByClassName("border-color");
      for(let i=0; i < elements.length; i++) {
        elements[i].style.borderColor = currentColor.color;
      }

      elements = document.getElementsByClassName("off-color");
      for(let i=0; i < elements.length; i++) {
        elements[i].style.color = currentColor.off_color;
      }


      //關閉色彩對話方塊
      var modal = document.getElementById("modal");
      modal.open = false;
      var template = document.getElementById("fav-color");
      template.setAttribute("hidden", "hidden");    
    }

    function addCheckMark(color_name){
      currentColor.name = color_name;
      //先清除色塊上原有的勾選符號
      var colorPreviews = document.getElementsByClassName("color-preview");
      for (let i = 0; i < colorPreviews.length; i++){
        if (colorPreviews[i].innerHTML != "") {
          colorPreviews[i].innerHTML = "";
          break;
        }
      }

      //將點選色塊元素的內容加上勾選符號…
      var element = document.getElementById(color_name);
      if (element) element.innerHTML = "<i class='fas fa-check checkmark'></i>"; 
    }

    function getUID(year, month, date) {
      if (month < 10) month = '0' + month;  //如果數字是1位數的話，前面補0
      if (date < 10) date = '0' + date;
      return ''+year+month+date;
    }

    function fillInMonth(thisYear, thisMonth, thisDate){
      document.getElementById("cal-year").innerHTML = thisYear;
      document.getElementById("cal-month").innerHTML = getMonthName( thisMonth );

       // 填滿月曆表格日期
      var days = document.getElementsByTagName("TD"); //取得月曆表格html所有的TD標籤物件陣列
      
      var monthDays = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31]; //記錄每個月的天數
      if(thisYear % 400 == 0 || (thisYear % 4 == 0 && thisYear % 100 != 0 )) { monthDays[1] = 29; } //閏年的話，2月為29天

      //new Date(thisYear, thisMonth, 1)取得今年今月1日的Ddate日期物件，再用這個物件算出這一天是禮拜幾
      let firstDayThisMonthYear =  new Date(thisYear, thisMonth, 1).getDay(); 

      //  處理今日灰色背景
      if (document.getElementById("current-day")) { //確認是否有一個元素其id值為"current-day"？
        document.getElementById("current-day").removeAttribute("id");      
      }
      if (thisYear === new Date().getFullYear() && thisMonth === new Date().getMonth()) { //當要繪製的年月等於當年當月時…
          days[firstDayThisMonthYear + thisDate - 1].setAttribute("id", "current-day");
      }
      
      var uid;

      //填本月的天數，從1到本月的最後一天(取本月的天數)
      for (let i = 1; i <= monthDays[thisMonth]; i++) {
        
        uid = getUID(thisYear, thisMonth,i);
        // console.log(uid);

        days[i + firstDayThisMonthYear - 1].innerHTML = i;
        days[i + firstDayThisMonthYear - 1].classList.remove("color");
        days[i + firstDayThisMonthYear - 1].setAttribute("data-uid", uid);
      }

      //填上月的天數，從上個月的最後1天開始遞減地填
      let lastMonth = thisMonth - 1;
      if (lastMonth === -1) lastMonth = 11; //1月的"上個月"是12月
      let d = monthDays[lastMonth];
    
      for(let i = firstDayThisMonthYear - 1; i >= 0; i--){
        if (lastMonth == 11) {
          uid = getUID(thisYear-1, lastMonth,d);
  
        } else {
          uid = getUID(thisYear, lastMonth,d);
        }  
        // console.log(uid);
        days[i].innerHTML = d;
        days[i].classList.add("color");
        days[i].classList.remove("prev-month-last-day");
        days[i].setAttribute("data-uid", uid);
        d--;
      }
      if(firstDayThisMonthYear > 0) days[firstDayThisMonthYear-1].classList.add("prev-month-last-day");
      
      var nextMonth = thisMonth + 1;      

      //填下月的天數，從1到最後1格    
      for(let i = firstDayThisMonthYear  + monthDays[thisMonth], d = 1; i <= 41; i++, d++) {
        if (nextMonth == 12) {
          uid = getUID(thisYear+1, 0,d);
  
        } else {
          uid = getUID(thisYear, nextMonth,d);
        }
        // console.log(uid);
        days[i].innerHTML = d; 
        days[i].classList.add("color");
        days[i].setAttribute("data-uid", uid);
      }        
      changeColor();
    }

    function previousMonth(){
      // console.log("你按了上個月的按鍵…");
      thisMonth--;
      if(thisMonth === -1) {
        thisMonth = 11;
        thisYear--;
      }
      fillInMonth(thisYear, thisMonth, thisDate);    
    }

    function nextMonth(){
      // console.log("你按了下個月的按鍵…");
      thisMonth++;
      if(thisMonth === 12) {
        thisMonth = 0;
        thisYear++;
      }
      fillInMonth(thisYear, thisMonth, thisDate);        
    }

    document.onkeydown = function(e) {
      switch (e.keyCode) {
        case 37: previousMonth(); break;
        case 39: nextMonth(); break;
      }
    };
